Index: uspace/lib/cpp/include/internal/thread.hpp
===================================================================
--- uspace/lib/cpp/include/internal/thread.hpp	(revision e498a458cc25ff608f3e603116929f3a2be81a0d)
+++ uspace/lib/cpp/include/internal/thread.hpp	(revision 8733ce2a7030f26604790011ff9cb3fa0a6e26a0)
@@ -30,6 +30,6 @@
 #define LIBCPP_INTERNAL_THREAD
 
-namespace std
-{ // TODO: fix cheaders
+namespace std::hel
+{
     extern "C" {
         #include <fibril.h>
@@ -54,9 +54,9 @@
     struct threading_policy<fibril_tag>
     {
-        using mutex_type        = fibril_mutex_t;
-        using thread_type       = fid_t;
-        using condvar_type      = fibril_condvar_t;
-        using time_unit         = suseconds_t;
-        using shared_mutex_type = fibril_rwlock_t;
+        using mutex_type        = hel::fibril_mutex_t;
+        using thread_type       = hel::fid_t;
+        using condvar_type      = hel::fibril_condvar_t;
+        using time_unit         = hel::suseconds_t;
+        using shared_mutex_type = hel::fibril_rwlock_t;
 
         struct thread
@@ -65,20 +65,20 @@
             static thread_type create(Callable clbl, Payload& pld)
             {
-                return fibril_create(clbl, (void*)&pld);
+                return hel::fibril_create(clbl, (void*)&pld);
             }
 
             static void start(thread_type thr)
             {
-                fibril_add_ready(thr);
+                hel::fibril_add_ready(thr);
             }
 
             static thread_type this_thread()
             {
-                return fibril_get_id();
+                return hel::fibril_get_id();
             }
 
             static void yield()
             {
-                fibril_yield();
+                hel::fibril_yield();
             }
 
@@ -94,20 +94,20 @@
             static void init(mutex_type& mtx)
             {
-                fibril_mutex_initialize(&mtx);
+                hel::fibril_mutex_initialize(&mtx);
             }
 
             static void lock(mutex_type& mtx)
             {
-                fibril_mutex_lock(&mtx);
+                hel::fibril_mutex_lock(&mtx);
             }
 
             static void unlock(mutex_type& mtx)
             {
-                fibril_mutex_unlock(&mtx);
+                hel::fibril_mutex_unlock(&mtx);
             }
 
             static bool try_lock(mutex_type& mtx)
             {
-                return fibril_mutex_trylock(&mtx);
+                return hel::fibril_mutex_trylock(&mtx);
             }
 
@@ -123,25 +123,25 @@
             static void init(condvar_type& cv)
             {
-                fibril_condvar_initialize(&cv);
+                hel::fibril_condvar_initialize(&cv);
             }
 
             static void wait(condvar_type& cv, mutex_type& mtx)
             {
-                fibril_condvar_wait(&cv, &mtx);
+                hel::fibril_condvar_wait(&cv, &mtx);
             }
 
             static int wait_for(condvar_type& cv, mutex_type& mtx, time_unit timeout)
             {
-                return fibril_condvar_wait_timeout(&cv, &mtx, timeout);
+                return hel::fibril_condvar_wait_timeout(&cv, &mtx, timeout);
             }
 
             static void signal(condvar_type& cv)
             {
-                fibril_condvar_signal(&cv);
+                hel::fibril_condvar_signal(&cv);
             }
 
             static void broadcast(condvar_type& cv)
             {
-                fibril_condvar_broadcast(&cv);
+                hel::fibril_condvar_broadcast(&cv);
             }
         };
@@ -157,5 +157,5 @@
             static void sleep(time_unit time)
             {
-                fibril_usleep(time);
+                hel::fibril_usleep(time);
             }
         };
@@ -165,25 +165,25 @@
             static void init(shared_mutex_type& mtx)
             {
-                fibril_rwlock_initialize(&mtx);
+                hel::fibril_rwlock_initialize(&mtx);
             }
 
             static void lock(shared_mutex_type& mtx)
             {
-                fibril_rwlock_write_lock(&mtx);
+                hel::fibril_rwlock_write_lock(&mtx);
             }
 
             static void unlock(shared_mutex_type& mtx)
             {
-                fibril_rwlock_write_unlock(&mtx);
+                hel::fibril_rwlock_write_unlock(&mtx);
             }
 
             static void lock_shared(shared_mutex_type& mtx)
             {
-                fibril_rwlock_read_lock(&mtx);
+                hel::fibril_rwlock_read_lock(&mtx);
             }
 
             static void unlock_shared(shared_mutex_type& mtx)
             {
-                fibril_rwlock_read_unlock(&mtx);
+                hel::fibril_rwlock_read_unlock(&mtx);
             }
 