Index: uspace/lib/cpp/include/impl/ios.hpp
===================================================================
--- uspace/lib/cpp/include/impl/ios.hpp	(revision 6648ab33d956d82634fb7b457a8e08f19ed97c77)
+++ uspace/lib/cpp/include/impl/ios.hpp	(revision 9400dbec94a1380af462fa5108e90ffc0f045c13)
@@ -68,19 +68,19 @@
 
             using fmtflags = uint16_t;
-            static constexpr fmtflags boolalpha   = 0b'0000'0000'0000'0001;
-            static constexpr fmtflags dec         = 0b'0000'0000'0000'0010;
-            static constexpr fmtflags fixed       = 0b'0000'0000'0000'0100;
-            static constexpr fmtflags hex         = 0b'0000'0000'0000'1000;
-            static constexpr fmtflags internal    = 0b'0000'0000'0001'0000;
-            static constexpr fmtflags left        = 0b'0000'0000'0010'0000;
-            static constexpr fmtflags oct         = 0b'0000'0000'0100'0000;
-            static constexpr fmtflags right       = 0b'0000'0000'1000'0000;
-            static constexpr fmtflags scientific  = 0b'0000'0001'0000'0000;
-            static constexpr fmtflags showbase    = 0b'0000'0010'0000'0000;
-            static constexpr fmtflags showpoint   = 0b'0000'0100'0000'0000;
-            static constexpr fmtflags showpos     = 0b'0000'1000'0000'0000;
-            static constexpr fmtflags skipws      = 0b'0001'0000'0000'0000;
-            static constexpr fmtflags unitbuf     = 0b'0010'0000'0000'0000;
-            static constexpr fmtflags uppercase   = 0b'0100'0000'0000'0000;
+            static constexpr fmtflags boolalpha   = 0b0000'0000'0000'0001;
+            static constexpr fmtflags dec         = 0b0000'0000'0000'0010;
+            static constexpr fmtflags fixed       = 0b0000'0000'0000'0100;
+            static constexpr fmtflags hex         = 0b0000'0000'0000'1000;
+            static constexpr fmtflags internal    = 0b0000'0000'0001'0000;
+            static constexpr fmtflags left        = 0b0000'0000'0010'0000;
+            static constexpr fmtflags oct         = 0b0000'0000'0100'0000;
+            static constexpr fmtflags right       = 0b0000'0000'1000'0000;
+            static constexpr fmtflags scientific  = 0b0000'0001'0000'0000;
+            static constexpr fmtflags showbase    = 0b0000'0010'0000'0000;
+            static constexpr fmtflags showpoint   = 0b0000'0100'0000'0000;
+            static constexpr fmtflags showpos     = 0b0000'1000'0000'0000;
+            static constexpr fmtflags skipws      = 0b0001'0000'0000'0000;
+            static constexpr fmtflags unitbuf     = 0b0010'0000'0000'0000;
+            static constexpr fmtflags uppercase   = 0b0100'0000'0000'0000;
             static constexpr fmtflags adjustfield = left | right | internal;
             static constexpr fmtflags basefield   = dec  | oct   | hex;
@@ -129,5 +129,5 @@
 
                 private:
-                    static int init_cnt{};
+                    static int init_cnt;
             };
 
@@ -195,9 +195,9 @@
 
         private:
-            static int index_{};
-            static bool sync_{true};
-
-            static long ierror_{0};
-            static long perror_{nullptr};
+            static int index_;
+            static bool sync_;
+
+            static long ierror_;
+            static void* perror_;
             static constexpr size_t initial_size_{10};
 
@@ -282,5 +282,5 @@
                     rdstate_ = state | badbit;
 
-                if (((state | (rdbuf_ ? goodbit | badbit)) & exceptions_) == 0)
+                if (((state | (rdbuf_ ? goodbit : badbit)) & exceptions_) == 0)
                     return;
                 // TODO: Else throw failure.
@@ -380,20 +380,20 @@
                 width_      = rhs.width_;
                 precision_  = rhs.precision_;
-                fille_      = rhs.fill_;
+                fill_      = rhs.fill_;
                 locale_     = rhs.locale_;
 
-                delete[] iarray;
+                delete[] iarray_;
                 iarray_size_ = rhs.iarray_size_;
                 iarray_ = new long[iarray_size_];
 
                 for (size_t i = 0; i < iarray_size_; ++i)
-                    iarrai_[i] = rhs.iarray_[i];
-
-                delete[] parray;
+                    iarray_[i] = rhs.iarray_[i];
+
+                delete[] parray_;
                 parray_size_ = rhs.parray_size_;
                 parray_ = new long[parray_size_];
 
                 for (size_t i = 0; i < parray_size_; ++i)
-                    iarrai_[i] = rhs.parray_[i];
+                    parray_[i] = rhs.parray_[i];
 
                 for (auto& callback: callbacks_)
@@ -456,6 +456,6 @@
                 locale_ = locale();
 
-                iarray = nullptr;
-                parray = nullptr
+                iarray_ = nullptr;
+                parray_ = nullptr;
             }
 
@@ -527,5 +527,5 @@
                 swap(iarray_size_);
                 swap(parray_);
-                swap(parray_size_)
+                swap(parray_size_);
             }
 